diff --git a/retail/bootloader/source/arm7/main.arm7.c b/retail/bootloader/source/arm7/main.arm7.c
index 89f44e7ac..c8f947a66 100644
--- a/retail/bootloader/source/arm7/main.arm7.c
+++ b/retail/bootloader/source/arm7/main.arm7.c
@@ -719,10 +719,10 @@ int arm7_main(void) {
 	nocashMessage("Trying to patch the card...\n");
 
 	ce9Location = extendedMemory2 ? CARDENGINE_ARM9_LOCATION_DLDI_EXTMEM : CARDENGINE_ARM9_LOCATION_DLDI;
-	tonccpy((u32*)ce9Location, (u32*)CARDENGINE_ARM9_LOCATION_BUFFERED, 0x6000);
+	tonccpy((u32*)ce9Location, (u32*)CARDENGINE_ARM9_LOCATION_BUFFERED, 0x7000);
 	toncset((u32*)0x023E0000, 0, 0x10000);
 
-	if (!dldiPatchBinary((data_t*)ce9Location, 0x6000)) {
+	if (!dldiPatchBinary((data_t*)ce9Location, 0x7000)) {
 		nocashMessage("ce9 DLDI patch failed");
 		dbg_printf("ce9 DLDI patch failed");
 		dbg_printf("\n");
diff --git a/retail/cardengine/arm7/source/cardengine.c b/retail/cardengine/arm7/source/cardengine.c
index 846e4c95b..1a95bcc57 100644
--- a/retail/cardengine/arm7/source/cardengine.c
+++ b/retail/cardengine/arm7/source/cardengine.c
@@ -19,10 +19,12 @@
 #include <string.h> // memcpy
 #include <nds/ndstypes.h>
 #include <nds/fifomessages.h>
+#include <nds/dma.h>
 #include <nds/ipc.h>
-#include <nds/interrupts.h>
 #include <nds/system.h>
+#include <nds/interrupts.h>
 #include <nds/input.h>
+#include <nds/timers.h>
 #include <nds/arm7/audio.h>
 #include <nds/arm7/i2c.h>
 #include <nds/memory.h> // tNDSHeader
@@ -127,7 +129,50 @@ void rebootConsole(void) {
 	} else {
 		writePowerManagement(PM_CONTROL_REG,PM_SYSTEM_PWR);	// Shut down console
 	}
-	sharedAddr[3] = 0;
+}
+
+void reset(void) {
+	register int i;
+	
+	REG_IME = 0;
+
+	for (i = 0; i < 16; i++) {
+		SCHANNEL_CR(i) = 0;
+		SCHANNEL_TIMER(i) = 0;
+		SCHANNEL_SOURCE(i) = 0;
+		SCHANNEL_LENGTH(i) = 0;
+	}
+
+	REG_SOUNDCNT = 0;
+
+	// Clear out ARM7 DMA channels and timers
+	for (i = 0; i < 4; i++) {
+		DMA_CR(i) = 0;
+		DMA_SRC(i) = 0;
+		DMA_DEST(i) = 0;
+		TIMER_CR(i) = 0;
+		TIMER_DATA(i) = 0;
+	}
+
+	// Clear out FIFO
+	REG_IPC_SYNC = 0;
+	REG_IPC_FIFO_CR = IPC_FIFO_ENABLE | IPC_FIFO_SEND_CLEAR;
+	REG_IPC_FIFO_CR = 0;
+
+	REG_IE = 0;
+	REG_IF = ~0;
+	*(vu32*)(0x04000000 - 4) = 0;  // IRQ_HANDLER ARM7 version
+	*(vu32*)(0x04000000 - 8) = ~0; // VBLANK_INTR_WAIT_FLAGS, ARM7 version
+	REG_POWERCNT = 1;  // Turn off power to stuff
+
+	while (sharedAddr[0] != 0x544F4F42) { // 'BOOT'
+		while (REG_VCOUNT != 191) swiDelay(100);
+		while (REG_VCOUNT == 191) swiDelay(100);
+	}
+
+	// Start ARM7
+	VoidFn arm7code = (VoidFn)ndsHeader->arm7executeAddress;
+	arm7code();
 }
 
 
@@ -158,7 +203,7 @@ void myIrqHandlerVBlank(void) {
 	}
 
 	if (sharedAddr[3] == (vu32)0x52534554) {
-		rebootConsole();
+		reset();
 	}
 
 	if (0==(REG_KEYINPUT & (KEY_L | KEY_R | KEY_UP)) && !(REG_EXTKEYINPUT & KEY_A/*KEY_X*/)) {
diff --git a/retail/cardengine/arm7/source/inGameMenu.c b/retail/cardengine/arm7/source/inGameMenu.c
index 363ba585f..e546e8553 100644
--- a/retail/cardengine/arm7/source/inGameMenu.c
+++ b/retail/cardengine/arm7/source/inGameMenu.c
@@ -15,6 +15,7 @@ extern vu32* volatile sharedAddr;
 extern bool returnToMenu;
 
 extern void rebootConsole(void);
+extern void reset(void);
 
 void inGameMenu(void) {
 	sharedAddr[4] = 0x554E454D; // 'MENU'
@@ -49,7 +50,7 @@ void inGameMenu(void) {
 					exitMenu = true;
 					break;
 				case 0x54495551: // QUIT
-					rebootConsole();
+					reset();
 					exitMenu = true;
 					break;
 				case 0x524D4152: // RAMR
diff --git a/retail/cardengine/arm9/cardengine.ld.in b/retail/cardengine/arm9/cardengine.ld.in
index 4469955eb..1ba6ac04d 100644
--- a/retail/cardengine/arm9/cardengine.ld.in
+++ b/retail/cardengine/arm9/cardengine.ld.in
@@ -6,7 +6,7 @@ OUTPUT_ARCH(arm)
 
 MEMORY {
 
-	vram	: ORIGIN = CARDENGINE_ARM9_LOCATION_DLDI, LENGTH = 25K /* Main RAM */
+	vram	: ORIGIN = CARDENGINE_ARM9_LOCATION_DLDI, LENGTH = 26K /* Main RAM */
 }
 
 __vram_start	=	ORIGIN(vram);
diff --git a/retail/cardengine/arm9/include/dldi_patcher.h b/retail/cardengine/arm9/include/dldi_patcher.h
new file mode 100644
index 000000000..78ce74f61
--- /dev/null
+++ b/retail/cardengine/arm9/include/dldi_patcher.h
@@ -0,0 +1,33 @@
+/*-----------------------------------------------------------------
+
+ Copyright (C) 2005  Michael "Chishm" Chisholm
+
+ This program is free software; you can redistribute it and/or
+ modify it under the terms of the GNU General Public License
+ as published by the Free Software Foundation; either version 2
+ of the License, or (at your option) any later version.
+
+ This program is distributed in the hope that it will be useful,
+ but WITHOUT ANY WARRANTY; without even the implied warranty of
+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ GNU General Public License for more details.
+
+ You should have received a copy of the GNU General Public License
+ along with this program; if not, write to the Free Software
+ Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+
+ If you use this code, please give due credit and email me about your
+ project at chishm@hotmail.com
+------------------------------------------------------------------*/
+
+#ifndef DLDI_PATCHER_H
+#define DLDI_PATCHER_H
+
+#include <nds/ndstypes.h>
+
+typedef signed int addr_t;
+typedef unsigned char data_t;
+bool dldiRelocate (u32 default_location, u32 current_location, u32 binSize);
+bool dldiPatchBinary (data_t *binData, u32 binSize);
+
+#endif // DLDI_PATCHER_H
diff --git a/retail/cardengine/arm9/source/cardengine.c b/retail/cardengine/arm9/source/cardengine.c
index fa7b0bcd3..50eac24a8 100644
--- a/retail/cardengine/arm9/source/cardengine.c
+++ b/retail/cardengine/arm9/source/cardengine.c
@@ -21,9 +21,12 @@
 #include <nds/ndstypes.h>
 #include <nds/arm9/exceptions.h>
 #include <nds/arm9/cache.h>
+#include <nds/arm9/video.h>
 #include <nds/system.h>
+#include <nds/dma.h>
 #include <nds/interrupts.h>
 #include <nds/ipc.h>
+#include <nds/timers.h>
 #include <nds/fifomessages.h>
 #include <nds/memory.h> // tNDSHeader
 #include "hex.h"
@@ -114,6 +117,17 @@ static void enableIPC_SYNC(void) {
 	}
 }
 
+void __attribute__((target("arm"))) mpuFullRam() {
+	asm("LDR R0,=#0x2000031\n\tmcr p15, 0, r0, C6,C1,0");
+}
+
+static inline void dmaFill(const void* src, void* dest, u32 size) {
+	DMA_SRC(3)  = (u32)src;
+	DMA_DEST(3) = (u32)dest;
+	DMA_CR(3)   = DMA_COPY_WORDS | DMA_SRC_FIX | (size>>2);
+	while (DMA_CR(3) & DMA_BUSY);
+}
+
 void user_exception(void);
 
 //---------------------------------------------------------------------------------
@@ -126,6 +140,98 @@ void setExceptionHandler2() {
 	*exceptionC = user_exception;
 }
 
+void reset(u32 param) {
+	setDeviceOwner();
+	*(u32*)((ce9->valueBits & isSdk5) ? RESET_PARAM_SDK5 : RESET_PARAM) = param;
+	fileWrite((char*)((ce9->valueBits & isSdk5) ? RESET_PARAM_SDK5 : RESET_PARAM), srParamsFile, 0, 0x10);
+	sharedAddr[3] = 0x52534554;
+
+	EXCEPTION_VECTOR_SDK1 = 0;
+
+	volatile u32 arm9_BLANK_RAM = 0;
+ 	register int i;
+
+	REG_IME = 0;
+	REG_IE = 0;
+	REG_IF = ~0;
+
+	// Clear out ARM9 DMA channels
+	for (i = 0; i < 4; i++) {
+		DMA_CR(i) = 0;
+		DMA_SRC(i) = 0;
+		DMA_DEST(i) = 0;
+		TIMER_CR(i) = 0;
+		TIMER_DATA(i) = 0;
+	}
+
+	// Clear out FIFO
+	REG_IPC_SYNC = 0;
+	REG_IPC_FIFO_CR = IPC_FIFO_ENABLE | IPC_FIFO_SEND_CLEAR;
+	REG_IPC_FIFO_CR = 0;
+
+	VRAM_A_CR = 0x80;
+	VRAM_B_CR = 0x80;
+	VRAM_C_CR = 0x80;
+	VRAM_D_CR = 0x80;
+	VRAM_E_CR = 0x80;
+	VRAM_F_CR = 0x80;
+	VRAM_G_CR = 0x80;
+	VRAM_H_CR = 0x80;
+	VRAM_I_CR = 0x80;
+	BG_PALETTE[0] = 0xFFFF;
+	dmaFill((u16*)&arm9_BLANK_RAM, BG_PALETTE+1, (2*1024)-2);
+	dmaFill((u16*)&arm9_BLANK_RAM, OAM, 2*1024);
+	dmaFill((u16*)&arm9_BLANK_RAM, (u16*)0x04000000, 0x56);  // Clear main display registers
+	dmaFill((u16*)&arm9_BLANK_RAM, (u16*)0x04001000, 0x56);  // Clear sub display registers
+	dmaFill((u16*)&arm9_BLANK_RAM, VRAM_A, 0x20000*3);		// Banks A, B, C
+	dmaFill((u16*)&arm9_BLANK_RAM, VRAM_D, 272*1024);		// Banks D (excluded), E, F, G, H, I
+
+	REG_DISPSTAT = 0;
+
+	VRAM_A_CR = 0;
+	VRAM_B_CR = 0;
+	VRAM_C_CR = 0;
+	VRAM_D_CR = 0;
+	VRAM_E_CR = 0;
+	VRAM_F_CR = 0;
+	VRAM_G_CR = 0;
+	VRAM_H_CR = 0;
+	VRAM_I_CR = 0;
+	WRAM_CR = 0; 	// Set shared ram to ARM9
+	REG_POWERCNT = 0x820F;
+
+	mpuFullRam();
+
+	*(u32*)(0x02000000) = BIT(0) | BIT(1);
+	if (param == 0xFFFFFFFF) {
+		*(u32*)(0x02000000) |= BIT(2);
+	}
+	dmaFill((u16*)&arm9_BLANK_RAM, (u16*)0x02004000, 0x3D9000 - 0x4000);
+	dmaFill((u16*)&arm9_BLANK_RAM, (u16*)0x023E0000, 0x1E000);
+
+	ndsHeader = (tNDSHeader*)NDS_HEADER_SDK5;
+
+	aFile bootNds = getBootFileCluster("BOOT.NDS");
+	fileRead((char*)ndsHeader, bootNds, 0, 0x170);
+	fileRead(ndsHeader->arm9destination, bootNds, ndsHeader->arm9romOffset, ndsHeader->arm9binarySize);
+	fileRead(ndsHeader->arm7destination, bootNds, ndsHeader->arm7romOffset, ndsHeader->arm7binarySize);
+
+	// Set shared ram to ARM7
+	WRAM_CR = 0x03;
+
+	if (!dldiPatchBinary(ndsHeader->arm9destination, ndsHeader->arm9binarySize)) {
+		while (1);
+	}
+
+	sharedAddr[0] = 0x544F4F42; // 'BOOT'
+	while (REG_VCOUNT != 191);
+	while (REG_VCOUNT == 191);
+
+	// Start ARM9
+	VoidFn arm9code = (VoidFn)ndsHeader->arm9executeAddress;
+	arm9code();
+}
+
 s8 mainScreen = 0;
 
 //---------------------------------------------------------------------------------
@@ -211,6 +317,10 @@ void myIrqHandlerIPC(void) {
 			volatile void (*inGameMenu)(s8*) = (volatile void*)INGAME_MENU_LOCATION_B4DS+0x40C;
 			(*inGameMenu)(&mainScreen);
 
+			if (sharedAddr[3] == 0x52534554) {
+				reset(0xFFFFFFFF);
+			}
+
 			fileWrite((char*)INGAME_MENU_LOCATION_B4DS, pageFile, 0, 0xA000);	// Store in-game menu
 			fileRead((char*)INGAME_MENU_LOCATION_B4DS, pageFile, 0xA000, 0xA000);	// Restore part of game RAM from page file
 
@@ -299,14 +409,10 @@ void __attribute__((target("arm"))) region0Fix() {
 	asm("LDR R0,=#0x4000033\n\tmcr p15, 0, r0, C6,C0,0");
 }
 
-void __attribute__((target("arm"))) sdk5MpuFix() {
-	asm("LDR R0,=#0x2000031\n\tmcr p15, 0, r0, C6,C1,0");
-}
-
 int cardRead(u32* cacheStruct, u8* dst0, u32 src0, u32 len0) {
 	if (!mpuSet) {
 		if ((ce9->valueBits & isSdk5) && ndsHeader->unitCode > 0 && ndsHeader->unitCode < 3) {
-			sdk5MpuFix();
+			mpuFullRam();
 		}
 		if (region0FixNeeded) {
 			region0Fix();
@@ -366,14 +472,6 @@ bool nandWrite(void* memory,void* flash,u32 len,u32 dma) {
 }
 
 
-void reset(u32 param) {
-	setDeviceOwner();
-	*(u32*)((ce9->valueBits & isSdk5) ? RESET_PARAM_SDK5 : RESET_PARAM) = param;
-	fileWrite((char*)((ce9->valueBits & isSdk5) ? RESET_PARAM_SDK5 : RESET_PARAM), srParamsFile, 0, 0x10);
-	sharedAddr[3] = 0x52534554;
-	while (1);
-}
-
 u32 myIrqEnable(u32 irq) {	
 	int oldIME = enterCriticalSection();
 	u16 exmemcnt = REG_EXMEMCNT;
diff --git a/retail/cardengine/arm9/source/dldi_patcher.c b/retail/cardengine/arm9/source/dldi_patcher.c
new file mode 100644
index 000000000..541a23437
--- /dev/null
+++ b/retail/cardengine/arm9/source/dldi_patcher.c
@@ -0,0 +1,213 @@
+/*-----------------------------------------------------------------
+
+ Copyright (C) 2005  Michael "Chishm" Chisholm
+
+ This program is free software; you can redistribute it and/or
+ modify it under the terms of the GNU General Public License
+ as published by the Free Software Foundation; either version 2
+ of the License, or (at your option) any later version.
+
+ This program is distributed in the hope that it will be useful,
+ but WITHOUT ANY WARRANTY; without even the implied warranty of
+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ GNU General Public License for more details.
+
+ You should have received a copy of the GNU General Public License
+ along with this program; if not, write to the Free Software
+ Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+
+ If you use this code, please give due credit and email me about your
+ project at chishm@hotmail.com
+------------------------------------------------------------------*/
+#ifndef NO_DLDI
+#include <string.h>
+#include <nds.h>
+#include "dldi_patcher.h"
+#include "tonccpy.h"
+
+#define FIX_ALL	0x01
+#define FIX_GLUE	0x02
+#define FIX_GOT	0x04
+#define FIX_BSS	0x08
+
+enum DldiOffsets {
+	DO_magicString = 0x00,			// "\xED\xA5\x8D\xBF Chishm"
+	DO_magicToken = 0x00,			// 0xBF8DA5ED
+	DO_magicShortString = 0x04,		// " Chishm"
+	DO_version = 0x0C,
+	DO_driverSize = 0x0D,
+	DO_fixSections = 0x0E,
+	DO_allocatedSpace = 0x0F,
+
+	DO_friendlyName = 0x10,
+
+	DO_text_start = 0x40,			// Data start
+	DO_data_end = 0x44,				// Data end
+	DO_glue_start = 0x48,			// Interworking glue start	-- Needs address fixing
+	DO_glue_end = 0x4C,				// Interworking glue end
+	DO_got_start = 0x50,			// GOT start					-- Needs address fixing
+	DO_got_end = 0x54,				// GOT end
+	DO_bss_start = 0x58,			// bss start					-- Needs setting to zero
+	DO_bss_end = 0x5C,				// bss end
+
+	// IO_INTERFACE data
+	DO_ioType = 0x60,
+	DO_features = 0x64,
+	DO_startup = 0x68,	
+	DO_isInserted = 0x6C,	
+	DO_readSectors = 0x70,	
+	DO_writeSectors = 0x74,
+	DO_clearStatus = 0x78,
+	DO_shutdown = 0x7C,
+	DO_code = 0x80
+};
+
+static addr_t readAddr (data_t *mem, addr_t offset) {
+	return ((addr_t*)mem)[offset/sizeof(addr_t)];
+}
+
+static void writeAddr (data_t *mem, addr_t offset, addr_t value) {
+	((addr_t*)mem)[offset/sizeof(addr_t)] = value;
+}
+
+
+static addr_t quickFind (const data_t* data, const data_t* search, size_t dataLen, size_t searchLen) {
+	const int* dataChunk = (const int*) data;
+	int searchChunk = ((const int*)search)[0];
+	addr_t i;
+	addr_t dataChunkEnd = (addr_t)(dataLen / sizeof(int));
+
+	for ( i = 0; i < dataChunkEnd; i++) {
+		if (dataChunk[i] == searchChunk) {
+			if ((i*sizeof(int) + searchLen) > dataLen) {
+				return -1;
+			}
+			if (memcmp (&data[i*sizeof(int)], search, searchLen) == 0) {
+				return i*sizeof(int);
+			}
+		}
+	}
+
+	return -1;
+}
+
+data_t dldiMagicString[] = "\xED\xA5\x8D\xBF cHISHM";	// Normal DLDI file
+#define DEVICE_TYPE_DLDI 0x49444C44
+
+extern const u32 __myio_dldi;
+
+bool dldiPatchBinary (data_t *binData, u32 binSize) {
+
+	addr_t memOffset;			// Offset of DLDI after the file is loaded into memory
+	addr_t patchOffset;			// Position of patch destination in the file
+	addr_t relocationOffset;	// Value added to all offsets within the patch to fix it properly
+	addr_t ddmemOffset;			// Original offset used in the DLDI file
+	addr_t ddmemStart;			// Start of range that offsets can be in the DLDI file
+	addr_t ddmemEnd;			// End of range that offsets can be in the DLDI file
+	addr_t ddmemSize;			// Size of range that offsets can be in the DLDI file
+	addr_t addrIter;
+
+	size_t dldiFileSize = 0;
+
+	// Fix DLDI string
+	dldiMagicString[5] -= 0x20;
+	dldiMagicString[6] += 0x20;
+	dldiMagicString[7] += 0x20;
+	dldiMagicString[8] += 0x20;
+	dldiMagicString[9] += 0x20;
+	dldiMagicString[10] += 0x20;
+
+	// Find the DLDI reserved space in the file
+	patchOffset = quickFind (binData, dldiMagicString, binSize, sizeof(dldiMagicString));
+
+	if (patchOffset < 0) {
+		// does not have a DLDI section
+		return false;
+	}
+
+	data_t *pDH = (data_t*)(((u32*)(&__myio_dldi)) - 24);
+	data_t *pAH = &(binData[patchOffset]);
+
+	if (*((u32*)(pDH + DO_ioType)) == DEVICE_TYPE_DLDI) {
+		// No DLDI patch
+		return false;
+	}
+
+	if (pDH[DO_driverSize] > pAH[DO_allocatedSpace]) {
+		// Not enough space for patch
+		return false;
+	}
+	
+	dldiFileSize = 1 << pDH[DO_driverSize];
+
+	memOffset = readAddr (pAH, DO_text_start);
+	if (memOffset == 0) {
+			memOffset = readAddr (pAH, DO_startup) - DO_code;
+	}
+	ddmemOffset = readAddr (pDH, DO_text_start);
+	relocationOffset = memOffset - ddmemOffset;
+
+	ddmemStart = readAddr (pDH, DO_text_start);
+	ddmemSize = (1 << pDH[DO_driverSize]);
+	ddmemEnd = ddmemStart + ddmemSize;
+
+	// Remember how much space is actually reserved
+	pDH[DO_allocatedSpace] = pAH[DO_allocatedSpace];
+	// Copy the DLDI patch into the application
+	tonccpy (pAH, pDH, dldiFileSize);
+
+	// Fix the section pointers in the header
+	writeAddr (pAH, DO_text_start, readAddr (pAH, DO_text_start) + relocationOffset);
+	writeAddr (pAH, DO_data_end, readAddr (pAH, DO_data_end) + relocationOffset);
+	writeAddr (pAH, DO_glue_start, readAddr (pAH, DO_glue_start) + relocationOffset);
+	writeAddr (pAH, DO_glue_end, readAddr (pAH, DO_glue_end) + relocationOffset);
+	writeAddr (pAH, DO_got_start, readAddr (pAH, DO_got_start) + relocationOffset);
+	writeAddr (pAH, DO_got_end, readAddr (pAH, DO_got_end) + relocationOffset);
+	writeAddr (pAH, DO_bss_start, readAddr (pAH, DO_bss_start) + relocationOffset);
+	writeAddr (pAH, DO_bss_end, readAddr (pAH, DO_bss_end) + relocationOffset);
+	// Fix the function pointers in the header
+	writeAddr (pAH, DO_startup, readAddr (pAH, DO_startup) + relocationOffset);
+	writeAddr (pAH, DO_isInserted, readAddr (pAH, DO_isInserted) + relocationOffset);
+	writeAddr (pAH, DO_readSectors, readAddr (pAH, DO_readSectors) + relocationOffset);
+	writeAddr (pAH, DO_writeSectors, readAddr (pAH, DO_writeSectors) + relocationOffset);
+	writeAddr (pAH, DO_clearStatus, readAddr (pAH, DO_clearStatus) + relocationOffset);
+	writeAddr (pAH, DO_shutdown, readAddr (pAH, DO_shutdown) + relocationOffset);
+
+	// Put the correct DLDI magic string back into the DLDI header
+	tonccpy (pAH, dldiMagicString, sizeof (dldiMagicString));
+
+	if (pDH[DO_fixSections] & FIX_ALL) { 
+		// Search through and fix pointers within the data section of the file
+		for (addrIter = (readAddr(pDH, DO_text_start) - ddmemStart); addrIter < (readAddr(pDH, DO_data_end) - ddmemStart); addrIter++) {
+			if ((ddmemStart <= readAddr(pAH, addrIter)) && (readAddr(pAH, addrIter) < ddmemEnd)) {
+				writeAddr (pAH, addrIter, readAddr(pAH, addrIter) + relocationOffset);
+			}
+		}
+	}
+
+	if (pDH[DO_fixSections] & FIX_GLUE) { 
+		// Search through and fix pointers within the glue section of the file
+		for (addrIter = (readAddr(pDH, DO_glue_start) - ddmemStart); addrIter < (readAddr(pDH, DO_glue_end) - ddmemStart); addrIter++) {
+			if ((ddmemStart <= readAddr(pAH, addrIter)) && (readAddr(pAH, addrIter) < ddmemEnd)) {
+				writeAddr (pAH, addrIter, readAddr(pAH, addrIter) + relocationOffset);
+			}
+		}
+	}
+
+	if (pDH[DO_fixSections] & FIX_GOT) { 
+		// Search through and fix pointers within the Global Offset Table section of the file
+		for (addrIter = (readAddr(pDH, DO_got_start) - ddmemStart); addrIter < (readAddr(pDH, DO_got_end) - ddmemStart); addrIter++) {
+			if ((ddmemStart <= readAddr(pAH, addrIter)) && (readAddr(pAH, addrIter) < ddmemEnd)) {
+				writeAddr (pAH, addrIter, readAddr(pAH, addrIter) + relocationOffset);
+			}
+		}
+	}
+
+	/*if (pDH[DO_fixSections] & FIX_BSS) { 
+		// Initialise the BSS to 0
+		toncset (&pAH[readAddr(pDH, DO_bss_start) - ddmemStart] , 0, readAddr(pDH, DO_bss_end) - readAddr(pDH, DO_bss_start));
+	}*/
+
+	return true;
+}
+#endif
\ No newline at end of file
diff --git a/retail/cardengine/arm9_extmem/cardengine.ld.in b/retail/cardengine/arm9_extmem/cardengine.ld.in
index b35499b66..e898476a9 100644
--- a/retail/cardengine/arm9_extmem/cardengine.ld.in
+++ b/retail/cardengine/arm9_extmem/cardengine.ld.in
@@ -6,7 +6,7 @@ OUTPUT_ARCH(arm)
 
 MEMORY {
 
-	vram	: ORIGIN = CARDENGINE_ARM9_LOCATION_DLDI_EXTMEM, LENGTH = 25K /* Main RAM */
+	vram	: ORIGIN = CARDENGINE_ARM9_LOCATION_DLDI_EXTMEM, LENGTH = 26K /* Main RAM */
 }
 
 __vram_start	=	ORIGIN(vram);
